#!/usr/bin/python

from time import sleep
from Adafruit_CharLCDPlate import Adafruit_CharLCDPlate
from subprocess import * 

cmd_ip = "ip addr show eth0 | grep inet | awk '{print $2}' | cut -d/ -f1"
cmd_cpu = "mpstat | awk '$11 ~ /[0-9.]+/ { print 100 - $11}'"
cmd_dfh = "df -h | grep /dev/root | awk '{ print $2 }'"
cmd_dfh_p = "df -h | grep /dev/root | awk '{ print $5 }'"
cmd_ps = "ps -ef | wc -l"

def run_cmd(cmd):
        p = Popen(cmd, shell=True, stdout=PIPE)
        output = p.communicate()[0]
        return output

class CPU(object):
   def __init__(self):
      """Init a CPU status object"""
      stat_fd = open('/proc/stat')
      stat_buf = stat_fd.readlines()[0].split()

      self.prev_total = float(stat_buf[1]) + float(stat_buf[2]) + float(stat_buf[3]) + float(stat_buf[4]) + float(stat_buf[5]) + float(stat_buf[6]) + float(stat_buf[7])
      self.prev_idle = float(stat_buf[4])
      stat_fd.close()

   def usage(self):
      """return the actual usage of cpu (in %)"""	
      stat_fd = open('/proc/stat')
      stat_buf = stat_fd.readlines()[0].split()
      total = float(stat_buf[1]) + float(stat_buf[2]) + float(stat_buf[3]) + float(stat_buf[4]) + float(stat_buf[5]) + float(stat_buf[6]) + float(stat_buf[7])
      idle = float(stat_buf[4])
      stat_fd.close()
      diff_idle = idle - self.prev_idle
      diff_total = total - self.prev_total
      usage = 1000.0 * (diff_total - diff_idle) / diff_total
      usage = usage / 10
      usage = round(usage, 1)
      self.prev_total = total
      self.prev_idle = idle
      return usage


   def memUsage():
      free_fd = os.popen('free -b')
      free_buf = free_fd.readlines()[1].split()
      usage = (float(free_buf[2]) / (float(free_buf[1]))) * 100
      usage = round(usage, 1)
      return usage

cpu = CPU()

# Initialize the LCD plate.  Should auto-detect correct I2C bus.  If not,
# pass '0' for early 256 MB Model B boards or '1' for all later versions
lcd = Adafruit_CharLCDPlate()

# Clear display and show greeting, pause 1 sec
lcd.clear()
lcd.message("  RaspberryPi\n ElettronicaIn")
sleep(5)
lcd.clear()
lcd.message("P1=M P2=IP P3=CPU\nP4=DSK  P5=Proc.")

# Poll buttons, display message & set backlight accordingly
btn = ((lcd.LEFT  , 'Pulsante 1' , lcd.BLUE),
       (lcd.UP    , 'Pulsante 2' , lcd.BLUE),
       (lcd.DOWN  , 'Pulsante 3' , lcd.BLUE),
       (lcd.RIGHT , 'Pulsante 4' , lcd.BLUE),
       (lcd.SELECT, ''           , lcd.ON))
prev = -1

while True:
    pin5 = lcd.buttonpin5()
    pin6 = lcd.buttonpin6()
    pin7 = lcd.buttonpin7()
    pinT = pin5 * 100 + pin6 * 10 + pin7
    pinS = ("000" + str(pinT))[-3:]

    for b in btn:
        if lcd.buttonPressed(b[0]):
            if b is not prev:
                print b[0]
                if b[0] == 0:
                   lcd.clear()
                   lcd.backlight(lcd.ON)
                   ps = run_cmd(cmd_ps)
                   lcd.message('N.Processi %s\nP1=Menu  pin %s' % (ps , str(pinS) ))
                elif b[0] == 1:
                   lcd.clear()
                   lcd.backlight(lcd.ON)
                   ipaddr = run_cmd(cmd_ip)
                   lcd.message('IP %s \nP1=Menu  pin %s' % ( ipaddr , str(pinS) ))
                elif b[0] == 2:
                   lcd.clear()
                   lcd.backlight(lcd.ON)
                   dfh = run_cmd(cmd_dfh)
                   dfh_p = run_cmd(cmd_dfh_p)
                   lcd.message('DSK %s USED %s\nP1=Menu  pin %s' % (dfh.strip(), dfh_p.strip() , str(pinS)))
                elif b[0] == 3:
                   lcd.clear()
                   lcd.backlight(lcd.ON)
                   cpu1 = float(cpu.usage())
                   lcd.message('CPU %.2f%%\nP1=Menu  pin %s' % (cpu1 , str(pinS)))
                elif b[0] == 4:
                   lcd.clear()
                   lcd.backlight(lcd.ON)
                   lcd.message("P1=M P2=IP P3=CPU\nP4=DSK  P5=Proc.")
                prev = b
            break
